From 08c340864abfbb3ef42963ff1601b00cfaff9976 Mon Sep 17 00:00:00 2001
From: Stefan Marr <git@stefan-marr.de>
Date: Fri, 22 Oct 2010 11:15:03 -0700
Subject: [PATCH] Necessary adaptations to code coming directly from Squeak.

---
 .../Cross/plugins/FilePlugin/FilePlugin.c          |   13 +-
 .../Cross/plugins/FilePlugin/FilePlugin.h          |    8 +-
 .../plugins/FilePlugin/sqFilePluginBasicPrims.c    |   14 +-
 .../Cross/plugins/FilePlugin/sqUnixFile.c          |   26 +-
 .../Cross/plugins/RePlugin/sqr_config.h            |  199 +++++++++++
 vm/src/from_squeak/Cross/vm/sqVirtualMachine.h     |    4 +-
 .../Cross/vm/{sqNamedPrims.c => sqrNamedPrims.c}   |   26 +-
 .../vm/{sqVirtualMachine.c => sqrVirtualMachine.c} |   15 +-
 .../from_squeak/intplugins/B2DPlugin/B2DPlugin.c   |   36 +-
 .../intplugins/BitBltPlugin/BitBltPlugin.c         |  375 +++++++++++---------
 .../intplugins/LargeIntegers/LargeIntegers.c       |   34 +-
 .../intplugins/SoundPlugin/SoundPlugin.c           |   12 +-
 .../intplugins/SoundPlugin/sqUnixSound.c           |   20 +-
 .../UnixOSProcessPlugin/UnixOSProcessPlugin.c      |   24 ++-
 .../from_squeak/unix/vm-display-X11/sqUnixXdnd.c   |   30 +-
 .../vm-display-X11/{sqUnixX11.c => sqrUnixX11.c}   |   83 +++--
 .../{sqUnixSoundMacOSX.c => sqrUnixSoundMacOSX.c}  |  135 ++++----
 .../unix/vm-sound-custom/sqUnixCustomSound.c       |    2 +-
 .../unix/vm-sound-null/sqUnixSoundNull.c           |   18 +-
 vm/src/from_squeak/unix/vm/aio.c                   |   30 +-
 vm/src/from_squeak/unix/vm/dlfcn-dyld.c            |   22 +-
 vm/src/from_squeak/unix/vm/sq.h                    |   20 +-
 vm/src/from_squeak/unix/vm/sqMemoryAccess.h        |   20 +-
 vm/src/from_squeak/unix/vm/sqNamedPrims.h          |    8 +
 vm/src/from_squeak/unix/vm/sqPlatformSpecific.h    |   22 +-
 vm/src/from_squeak/unix/vm/sqUnixCharConv.h        |   22 +-
 vm/src/from_squeak/unix/vm/sqUnixEvent.c           |   18 +-
 vm/src/from_squeak/unix/vm/sqaio.h                 |   16 +-
 .../vm/{sqUnixCharConv.c => sqrUnixCharConv.c}     |   42 ++-
 ...qUnixExternalPrims.c => sqrUnixExternalPrims.c} |   30 +-
 .../unix/vm/{sqUnixMain.c => sqrUnixMain.c}        |  223 +++++++-----
 31 files changed, 962 insertions(+), 585 deletions(-)
 create mode 100644 vm/src/from_squeak/Cross/plugins/RePlugin/sqr_config.h
 rename vm/src/from_squeak/Cross/vm/{sqNamedPrims.c => sqrNamedPrims.c} (95%)
 rename vm/src/from_squeak/Cross/vm/{sqVirtualMachine.c => sqrVirtualMachine.c} (98%)
 rename vm/src/from_squeak/unix/vm-display-X11/{sqUnixX11.c => sqrUnixX11.c} (98%)
 rename vm/src/from_squeak/unix/vm-sound-MacOSX/{sqUnixSoundMacOSX.c => sqrUnixSoundMacOSX.c} (97%)
 rename vm/src/from_squeak/unix/vm/{sqUnixCharConv.c => sqrUnixCharConv.c} (96%)
 rename vm/src/from_squeak/unix/vm/{sqUnixExternalPrims.c => sqrUnixExternalPrims.c} (98%)
 rename vm/src/from_squeak/unix/vm/{sqUnixMain.c => sqrUnixMain.c} (90%)

diff --git a/vm/src/from_squeak/Cross/plugins/FilePlugin/FilePlugin.c b/vm/src/from_squeak/Cross/plugins/FilePlugin/FilePlugin.c
index 74e7816..af33a47 100644
--- a/vm/src/from_squeak/Cross/plugins/FilePlugin/FilePlugin.c
+++ b/vm/src/from_squeak/Cross/plugins/FilePlugin/FilePlugin.c
@@ -112,11 +112,13 @@ static sqInt asciiDirectoryDelimiter(void) {
 
 /*	Open the named file, possibly checking security. Answer the file oop. */
 
-EXPORT(sqInt) fileOpenNamesizewritesecure(char * nameIndex, sqInt nameSize, sqInt writeFlag, sqInt secureFlag) {
+EXPORT(sqInt) fileOpenNamesizewritesecure(char * nameIndex_xxx_dmu, sqInt nameSize, sqInt writeFlag, sqInt secureFlag) {
     sqInt fileOop;
     sqInt okToOpen;
     SQFile * file;
 
+  char* nameIndex_xxx_dmu1 = malloc(nameSize);
+  memmove(nameIndex_xxx_dmu1, nameIndex_xxx_dmu, nameSize);
 	fileOop = interpreterProxy->instantiateClassindexableSize(interpreterProxy->classByteArray(), fileRecordSize());
 	/* begin fileValueOf: */
 	if (!((interpreterProxy->isBytes(fileOop)) && ((interpreterProxy->byteSizeOf(fileOop)) == (fileRecordSize())))) {
@@ -129,7 +131,7 @@ l1:	/* end fileValueOf: */;
 	if (!(interpreterProxy->failed())) {
 		if (secureFlag) {
 			if (sCOFfn != 0) {
-				okToOpen = ((sqInt (*) (char *, sqInt, sqInt)) sCOFfn)(nameIndex, nameSize, writeFlag);
+				okToOpen = ((sqInt (*) (char *, sqInt, sqInt)) sCOFfn)(nameIndex_xxx_dmu1, nameSize, writeFlag);
 				if (!(okToOpen)) {
 					interpreterProxy->primitiveFail();
 				}
@@ -137,8 +139,9 @@ l1:	/* end fileValueOf: */;
 		}
 	}
 	if (!(interpreterProxy->failed())) {
-		sqFileOpen(file, nameIndex, nameSize, writeFlag);
+		sqFileOpen(file, nameIndex_xxx_dmu1, nameSize, writeFlag);
 	}
+  free(nameIndex_xxx_dmu1);
 	return fileOop;
 }
 
@@ -318,7 +321,7 @@ EXPORT(sqInt) primitiveDirectoryDelimitor(void) {
 		return interpreterProxy->primitiveFail();
 	}
 	interpreterProxy->pop(1);
-	interpreterProxy->push(interpreterProxy->fetchPointerofObject(ascii, interpreterProxy->characterTable()));
+	interpreterProxy->push(interpreterProxy->fetchPointerofObject(ascii, interpreterProxy->characterTable())); // OK xxx_dmu
 }
 
 EXPORT(sqInt) primitiveDirectoryGetMacTypeAndCreator(void) {
@@ -384,7 +387,7 @@ EXPORT(sqInt) primitiveDirectoryLookup(void) {
 	}
 	pathNameIndex = interpreterProxy->firstIndexableField(pathName);
 
-	/* If the security plugin can be loaded, use it to check for permission. 
+	/* If the security plugin can be loaded, use it to check for permission.
 	If not, assume it's ok */
 
 	pathNameSize = interpreterProxy->byteSizeOf(pathName);
diff --git a/vm/src/from_squeak/Cross/vm/sqVirtualMachine.h b/vm/src/from_squeak/Cross/vm/sqVirtualMachine.h
index e73f8e5..37afd59 100644
--- a/vm/src/from_squeak/Cross/vm/sqVirtualMachine.h
+++ b/vm/src/from_squeak/Cross/vm/sqVirtualMachine.h
@@ -174,7 +174,7 @@ typedef struct VirtualMachine {
 
 #if VM_PROXY_MINOR > 3
 
-	void *(*ioLoadFunctionFrom)(char *fnName, char *modName);
+	void *(*ioLoadFunctionFrom)(const char *fnName, const char *modName);
 	sqInt (*ioMicroMSecs)(void);
 
 #endif
@@ -205,7 +205,7 @@ typedef struct VirtualMachine {
 	sqInt  (*fetchLong32ofObject)(sqInt fieldFieldIndex, sqInt oop);
 	sqInt  (*getThisSessionID)(void);
 	sqInt	  (*ioFilenamefromStringofLengthresolveAliases)(char* aCharBuffer, char* filenameIndex, sqInt filenameLength, sqInt resolveFlag);
-	sqInt  (*vmEndianness)(void);	
+	sqInt  (*vmEndianness)(void);
 #endif
 
 
diff --git a/vm/src/from_squeak/Cross/vm/sqNamedPrims.c b/vm/src/from_squeak/Cross/vm/sqrNamedPrims.c
similarity index 95%
rename from vm/src/from_squeak/Cross/vm/sqNamedPrims.c
rename to vm/src/from_squeak/Cross/vm/sqrNamedPrims.c
index ecaa0a0..8330242 100644
--- a/vm/src/from_squeak/Cross/vm/sqNamedPrims.c
+++ b/vm/src/from_squeak/Cross/vm/sqrNamedPrims.c
@@ -1,5 +1,5 @@
 /****************************************************************************
-*   PROJECT: Squeak 
+*   PROJECT: Squeak
 *   FILE:    sqNamedPrims.c
 *   CONTENT: Generic (cross platform) named primitive support
 *
@@ -195,7 +195,7 @@ static int callInitializersIn(ModuleEntry *module)
 		/* Note: older plugins may not export the compiled module name */
 		dprintf(("WARNING: getModuleName() not found in %s\n", module->name));
 	}
-	if(!init1) { 
+	if(!init1) {
 		dprintf(("ERROR: setInterpreter() not found\n"));
 		return 0;
 	}
@@ -262,7 +262,7 @@ static ModuleEntry *findAndLoadModule(char *pluginName, int ffiLoad)
 }
 
 /* findOrLoadModule:
-	Look if the given module is already loaded. 
+	Look if the given module is already loaded.
 	If so, return it's handle, otherwise try to load it.
 */
 static ModuleEntry *findOrLoadModule(char *pluginName, int ffiLoad)
@@ -289,7 +289,7 @@ static ModuleEntry *findOrLoadModule(char *pluginName, int ffiLoad)
 	Return the function address if successful, otherwise 0.
 	This entry point is called from the interpreter proxy.
 */
-void *ioLoadFunctionFrom(char *functionName, char *pluginName)
+void *ioLoadFunctionFrom(const char *functionName, const char *pluginName)
 {
 	ModuleEntry *module;
 
@@ -313,8 +313,8 @@ void *ioLoadFunctionFrom(char *functionName, char *pluginName)
 void *ioLoadExternalFunctionOfLengthFromModuleOfLength(sqInt functionNameIndex, sqInt functionNameLength,
 						       sqInt moduleNameIndex,   sqInt moduleNameLength)
 {
-	char *functionNamePointer= pointerForOop(functionNameIndex);
-	char *moduleNamePointer= pointerForOop(moduleNameIndex);
+	char *functionNamePointer= pointerForIndex_xxx_dmu(functionNameIndex);
+	char *moduleNamePointer= pointerForIndex_xxx_dmu(moduleNameIndex);
 	char functionName[256];
 	char moduleName[256];
 	int i;
@@ -335,7 +335,7 @@ void *ioLoadExternalFunctionOfLengthFromModuleOfLength(sqInt functionNameIndex,
 */
 void *ioLoadSymbolOfLengthFromModule(sqInt functionNameIndex, sqInt functionNameLength, void *moduleHandle)
 {
-	char *functionNamePointer= pointerForOop(functionNameIndex);
+	char *functionNamePointer= pointerForIndex_xxx_dmu(functionNameIndex);
 	char functionName[256];
 	int i;
 
@@ -358,7 +358,7 @@ void *ioLoadSymbolOfLengthFromModule(sqInt functionNameIndex, sqInt functionName
 void *ioLoadModuleOfLength(sqInt moduleNameIndex, sqInt moduleNameLength)
 {
 	ModuleEntry *module;
-	char *moduleNamePointer= pointerForOop(moduleNameIndex);
+	char *moduleNamePointer= pointerForIndex_xxx_dmu(moduleNameIndex);
 	char moduleName[256];
 	int i;
 
@@ -446,7 +446,7 @@ sqInt ioUnloadModule(char *moduleName)
 */
 sqInt ioUnloadModuleOfLength(sqInt moduleNameIndex, sqInt moduleNameLength)
 {
-	char *moduleNamePointer= pointerForOop(moduleNameIndex);
+	char *moduleNamePointer= pointerForIndex_xxx_dmu(moduleNameIndex);
 	char moduleName[256];
 	int i;
 
@@ -519,3 +519,11 @@ char *ioListLoadedModule(sqInt moduleIndex) {
 	}
 	else return (char*)NULL;
 }
+
+
+
+void rvm_callInitializersInAllModules() {
+  findOrLoadModule("BitBltPlugin", 0);
+  // xxxxxx Which other modules?
+}
+
diff --git a/vm/src/from_squeak/Cross/vm/sqVirtualMachine.c b/vm/src/from_squeak/Cross/vm/sqrVirtualMachine.c
similarity index 98%
rename from vm/src/from_squeak/Cross/vm/sqVirtualMachine.c
rename to vm/src/from_squeak/Cross/vm/sqrVirtualMachine.c
index 5045c00..8451885 100644
--- a/vm/src/from_squeak/Cross/vm/sqVirtualMachine.c
+++ b/vm/src/from_squeak/Cross/vm/sqrVirtualMachine.c
@@ -3,6 +3,7 @@
 #include <stdlib.h>
 #include <string.h>
 #include <time.h>
+#include "squeak_adapters.h"
 #include "sqVirtualMachine.h"
 
 /*** Function prototypes ***/
@@ -41,7 +42,7 @@ sqInt  fetchPointerofObject(sqInt index, sqInt oop);
  * equivalent but 64 bit valid function is added as           *
  * 'fetchLong32OfObject'                                      */
 sqInt  obsoleteDontUseThisFetchWordofObject(sqInt index, sqInt oop);
-sqInt  fetchLong32ofObject(sqInt index, sqInt oop); 
+sqInt  fetchLong32ofObject(sqInt index, sqInt oop);
 void  *firstFixedField(sqInt oop);
 void  *firstIndexableField(sqInt oop);
 sqInt  literalofMethod(sqInt offset, sqInt methodPointer);
@@ -136,7 +137,7 @@ sqInt ioMicroMSecs(void);
 sqInt forceInterruptCheck(void);
 sqInt getThisSessionID(void);
 sqInt ioFilenamefromStringofLengthresolveAliases(char* aCharBuffer, char* filenameIndex, sqInt filenameLength, sqInt resolveFlag);
-sqInt  vmEndianness(void);	
+sqInt  vmEndianness(void);
 
 /* InterpreterProxy methodsFor: 'BitBlt support' */
 sqInt loadBitBltFrom(sqInt bbOop);
@@ -153,7 +154,7 @@ sqInt ioLoadModuleOfLength(sqInt moduleNameIndex, sqInt moduleNameLength);
 sqInt ioLoadSymbolOfLengthFromModule(sqInt functionNameIndex, sqInt functionNameLength, sqInt moduleHandle);
 sqInt isInMemory(sqInt address);
 
-void *ioLoadFunctionFrom(char *fnName, char *modName);
+void *ioLoadFunctionFrom(const char *fnName, const char *modName);
 
 struct VirtualMachine *VM = NULL;
 
@@ -189,7 +190,7 @@ struct VirtualMachine* sqGetInterpreterProxy(void)
 	VM->stackIntegerValue = stackIntegerValue;
 	VM->stackObjectValue = stackObjectValue;
 	VM->stackValue = stackValue;
-	
+
 	/* InterpreterProxy methodsFor: 'object access' */
 	VM->argumentCountOf = argumentCountOf;
 	VM->arrayValueOf = arrayValueOf;
@@ -215,7 +216,7 @@ struct VirtualMachine* sqGetInterpreterProxy(void)
 	VM->stSizeOf = stSizeOf;
 	VM->storeIntegerofObjectwithValue = storeIntegerofObjectwithValue;
 	VM->storePointerofObjectwithValue = storePointerofObjectwithValue;
-	
+
 	/* InterpreterProxy methodsFor: 'testing' */
 	VM->isKindOf = isKindOf;
 	VM->isMemberOf = isMemberOf;
@@ -245,7 +246,7 @@ struct VirtualMachine* sqGetInterpreterProxy(void)
 	VM->falseObject = falseObject;
 	VM->nilObject = nilObject;
 	VM->trueObject = trueObject;
-	
+
 	/* InterpreterProxy methodsFor: 'special classes' */
 	VM->classArray = classArray;
 	VM->classBitmap = classBitmap;
@@ -257,7 +258,7 @@ struct VirtualMachine* sqGetInterpreterProxy(void)
 	VM->classSemaphore = classSemaphore;
 	VM->classSmallInteger = classSmallInteger;
 	VM->classString = classString;
-	
+
 	/* InterpreterProxy methodsFor: 'instance creation' */
 	VM->clone = clone;
 	VM->instantiateClassindexableSize = instantiateClassindexableSize;
diff --git a/vm/src/from_squeak/intplugins/B2DPlugin/B2DPlugin.c b/vm/src/from_squeak/intplugins/B2DPlugin/B2DPlugin.c
index a18e538..8559a18 100644
--- a/vm/src/from_squeak/intplugins/B2DPlugin/B2DPlugin.c
+++ b/vm/src/from_squeak/intplugins/B2DPlugin/B2DPlugin.c
@@ -860,7 +860,7 @@ static sqInt addEdgeToGET(sqInt edge) {
 }
 
 
-/*	NOTE: 	This method is (hopefully) obsolete due to unrolling 
+/*	NOTE: 	This method is (hopefully) obsolete due to unrolling
 				the fill loops to deal with full pixels. */
 /*	Adjust the span buffers values by the appropriate color offset for anti-aliasing.
 	We do this by replicating the top bits of each color in the lower bits. The idea is that we can scale each color value uniquely from 0 to 255 and thus fill the entire range of colors. */
@@ -1521,7 +1521,7 @@ static sqInt checkCompressedPointssegments(sqInt points, sqInt nSegments) {
 }
 
 
-/*	Check if the given shape can be handled by the engine. 
+/*	Check if the given shape can be handled by the engine.
 	Since there are a number of requirements this is an extra method. */
 
 static sqInt checkCompressedShapesegmentsleftFillsrightFillslineWidthslineFillsfillIndexList(sqInt points, sqInt nSegments, sqInt leftFills, sqInt rightFills, sqInt lineWidths, sqInt lineFills, sqInt fillIndexList) {
@@ -1920,7 +1920,7 @@ l1:	/* end wbStackPush: */;
 }
 
 
-/*	Get both values from the two boundaries of the given bezier 
+/*	Get both values from the two boundaries of the given bezier
 	and compute the actual position/width of the line */
 
 static sqInt computeFinalWideBezierValueswidth(sqInt bezier, sqInt lineWidth) {
@@ -3968,7 +3968,7 @@ static sqInt findNextExternalFillFromAET(void) {
 	leftX = rightX = workBuffer[GWFillMaxX];
 	while ((workBuffer[GWAETStart]) < (workBuffer[GWAETUsed])) {
 
-		/* TODO: We should check if leftX from last operation 
+		/* TODO: We should check if leftX from last operation
 			is  greater than leftX from next edge.
 			Currently, we rely here on spanEndAA
 			from the span buffer fill. */
@@ -5956,7 +5956,7 @@ EXPORT(sqInt) moduleUnloaded(char * aModuleName) {
 }
 
 
-/*	The entry at index is not in the right position of the AET. 
+/*	The entry at index is not in the right position of the AET.
 	Move it to the left until the position is okay. */
 
 static sqInt moveAETEntryFromedgex(sqInt index, sqInt edge, sqInt xValue) {
@@ -6629,7 +6629,7 @@ EXPORT(sqInt) primitiveAddPolygon(void) {
 		return interpreterProxy->primitiveFail();
 	}
 	if (((lineFill == 0) || (lineWidth == 0)) && (fillIndex == 0)) {
-		return interpreterProxy->pop(6);
+		return interpreterProxy->pop(5); // was 6 DMU Squeak bug?
 	}
 	if (!(lineWidth == 0)) {
 		lineWidth = transformWidth(lineWidth);
@@ -6873,7 +6873,7 @@ EXPORT(sqInt) primitiveDisplaySpanBuffer(void) {
 	if (!(loadSpanBufferFrom(interpreterProxy->fetchPointerofObject(BESpanIndex, engine)))) {
 		return interpreterProxy->primitiveFail();
 	}
-	if (!(loadBitBltFrom(interpreterProxy->fetchPointerofObject(BEBitBltIndex, engine)))) {
+	if (!(loadBitBltFrom(interpreterProxy->fetchPointerofObject(BEBitBltIndex, engine)))) { // maybe xxx_dmu
 		return interpreterProxy->primitiveFail();
 	}
 	if (((workBuffer[GWCurrentY]) & (workBuffer[GWAAScanMask])) == (workBuffer[GWAAScanMask])) {
@@ -7088,7 +7088,7 @@ EXPORT(sqInt) primitiveGetFailureReason(void) {
 	if ((interpreterProxy->slotSizeOf(engine)) < BEBalloonEngineSize) {
 		return 0;
 	}
-	if (!(loadWorkBufferFrom(interpreterProxy->fetchPointerofObject(BEWorkBufferIndex, engine)))) {
+	if (!(loadWorkBufferFrom(interpreterProxy->fetchPointerofObject(BEWorkBufferIndex, engine)))) { // maybe xxx_dmu
 		return interpreterProxy->primitiveFail();
 	}
 	interpreterProxy->pop(1);
@@ -7213,7 +7213,7 @@ EXPORT(sqInt) primitiveInitializeProcessing(void) {
 	if (!(quickLoadEngineFromrequiredState(engine, GEStateUnlocked))) {
 		return interpreterProxy->primitiveFail();
 	}
-	if (!(loadSpanBufferFrom(interpreterProxy->fetchPointerofObject(BESpanIndex, engine)))) {
+	if (!(loadSpanBufferFrom(interpreterProxy->fetchPointerofObject(BESpanIndex, engine)))) { // maybe xxx_dmu
 		return interpreterProxy->primitiveFail();
 	}
 	initializeGETProcessing();
@@ -7257,7 +7257,7 @@ EXPORT(sqInt) primitiveMergeFillFrom(void) {
 	if (!(quickLoadEngineFromrequiredState(engine, GEStateWaitingForFill))) {
 		return interpreterProxy->primitiveFail();
 	}
-	if (!(loadSpanBufferFrom(interpreterProxy->fetchPointerofObject(BESpanIndex, engine)))) {
+	if (!(loadSpanBufferFrom(interpreterProxy->fetchPointerofObject(BESpanIndex, engine)))) { // maybe xxx_dmu
 		return interpreterProxy->primitiveFail();
 	}
 	if (!((interpreterProxy->fetchClassOf(bitsOop)) == (interpreterProxy->classBitmap()))) {
@@ -7416,10 +7416,10 @@ EXPORT(sqInt) primitiveNextFillEntry(void) {
 	if (!(quickLoadEngineFromrequiredState(engine, GEStateScanningAET))) {
 		return interpreterProxy->primitiveFail();
 	}
-	if (!(loadSpanBufferFrom(interpreterProxy->fetchPointerofObject(BESpanIndex, engine)))) {
+	if (!(loadSpanBufferFrom(interpreterProxy->fetchPointerofObject(BESpanIndex, engine)))) { // maybe xxx_dmu
 		return interpreterProxy->primitiveFail();
 	}
-	if (!(loadFormsFrom(interpreterProxy->fetchPointerofObject(BEFormsIndex, engine)))) {
+	if (!(loadFormsFrom(interpreterProxy->fetchPointerofObject(BEFormsIndex, engine)))) { // maybe xxx_dmu
 		return interpreterProxy->primitiveFail();
 	}
 	if (!((workBuffer[GWClearSpanBuffer]) == 0)) {
@@ -7717,8 +7717,8 @@ EXPORT(sqInt) primitiveSetClipRect(void) {
 	if ((interpreterProxy->slotSizeOf(rectOop)) < 2) {
 		return interpreterProxy->primitiveFail();
 	}
-	loadPointfrom(((int *) (workBuffer + GWPoint1)), interpreterProxy->fetchPointerofObject(0, rectOop));
-	loadPointfrom(((int *) (workBuffer + GWPoint2)), interpreterProxy->fetchPointerofObject(1, rectOop));
+	loadPointfrom(((int *) (workBuffer + GWPoint1)), interpreterProxy->fetchPointerofObject(0, rectOop)); // maybe xxx_dmu
+	loadPointfrom(((int *) (workBuffer + GWPoint2)), interpreterProxy->fetchPointerofObject(1, rectOop)); // maybe xxx_dmu
 	if (!(interpreterProxy->failed())) {
 		workBuffer[GWClipMinX] = ((((int *) (workBuffer + GWPoint1)))[0]);
 		workBuffer[GWClipMinY] = ((((int *) (workBuffer + GWPoint1)))[1]);
@@ -8073,7 +8073,7 @@ static sqInt quickLoadEngineFrom(sqInt engineOop) {
 		return 0;
 	}
 	engine = engineOop;
-	if (!(loadWorkBufferFrom(interpreterProxy->fetchPointerofObject(BEWorkBufferIndex, engineOop)))) {
+	if (!(loadWorkBufferFrom(interpreterProxy->fetchPointerofObject(BEWorkBufferIndex, engineOop)))) { // maybe xxx_dmu
 		return 0;
 	}
 	workBuffer[GWStopReason] = 0;
@@ -8411,7 +8411,7 @@ static sqInt showFilldepthrightX(sqInt fillIndex, sqInt depth, sqInt rightX) {
 }
 
 static int * smallSqrtTable(void) {
-    static int theTable[32] = 
+    static int theTable[32] =
 	{0, 1, 1, 2, 2, 2, 2, 3, 3, 3, 3, 3, 3, 4, 4, 4, 4, 4, 4, 4, 4, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 6};
 
 	return theTable;
@@ -8509,7 +8509,7 @@ static sqInt stepToFirstBezier(void) {
 
 
 /*	Initialize the bezier at yValue.
-	TODO: Check if reducing maxSteps from 2*deltaY to deltaY 
+	TODO: Check if reducing maxSteps from 2*deltaY to deltaY
 		brings a *significant* performance improvement.
 		In theory this should make for double step performance
 		but will cost in quality. Might be that the AA stuff will
@@ -9341,7 +9341,7 @@ static sqInt subdivideBezierFrom(sqInt index) {
 }
 
 
-/*	Check if the given bezier curve is monoton in Y, and, if desired in X. 
+/*	Check if the given bezier curve is monoton in Y, and, if desired in X.
 	If not, subdivide it */
 
 static sqInt subdivideToBeMonotoninX(sqInt base, sqInt doTestX) {
